# coding: utf-8

"""
    Geometry Backend API v2

    The ShapeDiver Geometry Backend system is used to: * host Grasshopper models in a secure, reliable, scalable, and performant way, * run computations of Grasshopper models, * and cache and output the results of computations and exports.

    The version of the OpenAPI document: 2.13.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List
from shapediver.geometry_api_v2.client.models.res_rate_limited_combined_metric import ResRateLimitedCombinedMetric
from shapediver.geometry_api_v2.client.models.res_rate_limited_computation_metric import ResRateLimitedComputationMetric
from shapediver.geometry_api_v2.client.models.res_rate_limited_export_metric import ResRateLimitedExportMetric
from shapediver.geometry_api_v2.client.models.res_rate_limited_output_metric import ResRateLimitedOutputMetric
from shapediver.geometry_api_v2.client.models.res_rate_limited_session_metric import ResRateLimitedSessionMetric
from typing import Optional, Set
from typing_extensions import Self

class ResLimitedCreditMetric(BaseModel):
    """
    Aggregated metrics for 'rate-limited timeslot' sessions.
    """ # noqa: E501
    outputs: ResRateLimitedOutputMetric
    exports: ResRateLimitedExportMetric
    combined: ResRateLimitedCombinedMetric
    sessions: ResRateLimitedSessionMetric
    computations: ResRateLimitedComputationMetric
    __properties: ClassVar[List[str]] = ["outputs", "exports", "combined", "sessions", "computations"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ResLimitedCreditMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of outputs
        if self.outputs:
            _dict['outputs'] = self.outputs.to_dict()
        # override the default output from pydantic by calling `to_dict()` of exports
        if self.exports:
            _dict['exports'] = self.exports.to_dict()
        # override the default output from pydantic by calling `to_dict()` of combined
        if self.combined:
            _dict['combined'] = self.combined.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sessions
        if self.sessions:
            _dict['sessions'] = self.sessions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of computations
        if self.computations:
            _dict['computations'] = self.computations.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ResLimitedCreditMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "outputs": ResRateLimitedOutputMetric.from_dict(obj["outputs"]) if obj.get("outputs") is not None else None,
            "exports": ResRateLimitedExportMetric.from_dict(obj["exports"]) if obj.get("exports") is not None else None,
            "combined": ResRateLimitedCombinedMetric.from_dict(obj["combined"]) if obj.get("combined") is not None else None,
            "sessions": ResRateLimitedSessionMetric.from_dict(obj["sessions"]) if obj.get("sessions") is not None else None,
            "computations": ResRateLimitedComputationMetric.from_dict(obj["computations"]) if obj.get("computations") is not None else None
        })
        return _obj


