# coding: utf-8

"""
    Geometry Backend API v2

    The ShapeDiver Geometry Backend system is used to: * host Grasshopper models in a secure, reliable, scalable, and performant way, * run computations of Grasshopper models, * and cache and output the results of computations and exports.

    The version of the OpenAPI document: 2.13.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ResParameterType(str, Enum):
    """
    Type of parameter.  All types starting with 's' are s-type parameters while the others are basic parameter types.
    """

    """
    allowed enum values
    """
    SBITMAP = 'sBitmap'
    SBOOL = 'sBool'
    SBOX = 'sBox'
    SBREP = 'sBrep'
    SCIRCLE = 'sCircle'
    SCOLOR = 'sColor'
    SCURVE = 'sCurve'
    SDOMAIN = 'sDomain'
    SDOMAIN2D = 'sDomain2D'
    SINTEGER = 'sInteger'
    SLINE = 'sLine'
    SMESH = 'sMesh'
    SNUMBER = 'sNumber'
    SPLANE = 'sPlane'
    SPOINT = 'sPoint'
    SRECTANGLE = 'sRectangle'
    SSTRING = 'sString'
    SSUBDIV = 'sSubdiv'
    SSURFACE = 'sSurface'
    STIME = 'sTime'
    SVECTOR = 'sVector'
    BOOL = 'Bool'
    COLOR = 'Color'
    DRAWING = 'Drawing'
    EVEN = 'Even'
    FILE = 'File'
    FLOAT = 'Float'
    INT = 'Int'
    INTERACTION = 'Interaction'
    ODD = 'Odd'
    STRING = 'String'
    STRINGLIST = 'StringList'
    TIME = 'Time'
    UNKNOWN = 'unknown'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ResParameterType from a JSON string"""
        return cls(json.loads(json_str))


