# coding: utf-8

"""
    Geometry Backend API v2

    The ShapeDiver Geometry Backend system is used to: * host Grasshopper models in a secure, reliable, scalable, and performant way, * run computations of Grasshopper models, * and cache and output the results of computations and exports.

    The version of the OpenAPI document: 2.13.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ResTexture(BaseModel):
    """
    Information about a model texture.
    """ # noqa: E501
    model_id: StrictStr = Field(description="The ID of the ShapeDiver model.", alias="modelId")
    texture_id: StrictStr = Field(description="The texture ID.", alias="textureId")
    url: Optional[StrictStr] = Field(default=None, description="The original URL of the texture asset.")
    width: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="The width of the texture.")
    height: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="The height of the texture.")
    is_asset_available: StrictBool = Field(description="Is `true` when the texture has been cached, otherwise `false`.", alias="isAssetAvailable")
    __properties: ClassVar[List[str]] = ["modelId", "textureId", "url", "width", "height", "isAssetAvailable"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ResTexture from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ResTexture from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "modelId": obj.get("modelId"),
            "textureId": obj.get("textureId"),
            "url": obj.get("url"),
            "width": obj.get("width"),
            "height": obj.get("height"),
            "isAssetAvailable": obj.get("isAssetAvailable")
        })
        return _obj


